//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "ClipReply.h"
#include "msgwin.h"
#include "fileman.h"
#include "global.h"
#include "headman.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMergeForm *MergeForm;
//---------------------------------------------------------------------------
void __fastcall ClipboardReply(bool UseDialog)
{
   TMemo *m = new TMemo((void*)NULL);
   m->Visible = false;
   m->WordWrap = false;
   m->Parent = Application->MainForm;
   m->PasteFromClipboard();
   TStrings *OrgMessage = m->Lines;
   THeadMan *headers = new THeadMan(OrgMessage);

   if(!headers->Has("Reply-To: ",OrgMessage) && !headers->Has("From: "))
   {
      MsgBox("Clipboard does not appear to contain\nan email message!","Reply Problem",MB_OK);
      TextWin = new TTextWin(Application->MainForm);
      TextWin->SetText("Clipboard Contents...",OrgMessage);
      delete m;
      return;
   }

   AnsiString TemplateName=DefaultMessage;
   if (UseDialog && (TemplateName=GetMergeMessage("Reply using...",modeMessage)).IsEmpty())
   {
      delete m;
      return;
   }

   ReplyToMessage(OrgMessage,TemplateName,"");
   delete m;
}
//---------------------------------------------------------------------------
void __fastcall ReplyToMessage(TStrings *Message, AnsiString &TemplateName,
   AnsiString &InReplyTo)
{
   AnsiString hdr,mID,pststr=QteMarks,replyto,blank;
   TStringList *Template = new TStringList();
   GetAppData(Template,TemplateName);

   TStringList *lines = new TStringList();
   THeaderManager *TmpMan = new THeaderManager(Template);
   THeaderManager *MsgMan = new THeaderManager(Message);
   // get special header positions from template if there
   while (!(hdr=TmpMan->PopHeader()).IsEmpty())
   {
      if (hdr.Pos("To: ")==1) hdr=MsgMan->Get4Reply("To: ");
      if (hdr.Pos("Subject: ")==1) hdr=MsgMan->Get4Reply("Subject: ");
      lines->Text = lines->Text + hdr;
   }
   hdr = "";
   // add special headers to end of headers if not handled above
   if (!lines->Text.Pos("To: ")) hdr=MsgMan->Get4Reply("To: ");
   if (!lines->Text.Pos("Subject: ")) hdr+=MsgMan->Get4Reply("Subject: ");
   if (!hdr.IsEmpty()) lines->Text = lines->Text + hdr;

   lines->Add("");
   lines->Add("On "+MsgMan->GetDat("Date: ")+", you wrote:");

   int i,eoh = MsgMan->Eoh();
   // add quoted message text to new message
   for (i=eoh; i<Message->Count; i++) lines->Add(pststr+Message->Strings[i]);
   lines->Add("");
   // remove trailing nulls from template
   while (Template->Count && Template->Strings[Template->Count-1].IsEmpty())
      Template->Delete(Template->Count-1);
   // copy template sig to lines
   for (i=1; i<Template->Count; i++) lines->Add(Template->Strings[i]);
   // give it to the user
   MessageWin = new TMessageWin(lines,blank,blank,Application->MainForm);
   MessageWin->InReplyTo = InReplyTo;
   delete MsgMan;
   delete TmpMan;
   delete lines;
   delete Template;
}
//---------------------------------------------------------------------------
void __fastcall ClipboardFollowup(bool UseDialog)
{
   TMemo *m = new TMemo((void*)NULL);
   m->Visible = false;
   m->WordWrap = false;
   m->Parent = Application->MainForm;
   m->PasteFromClipboard();
   TStrings *OrgArticle = m->Lines;
   THeadMan *headers = new THeadMan(OrgArticle);

   if(!headers->Has("Newsgroups: ",OrgArticle) && !headers->Has("Followup-To: "))
   {
      MsgBox("Clipboard does not appear to contain\na USENET article!","Followup Problem",MB_OK);
      TextWin = new TTextWin(Application->MainForm);
      TextWin->SetText("Clipboard Contents...",OrgArticle);
      delete m;
      return;
   }

   AnsiString TemplateName=DefaultArticle;
   if (UseDialog && (TemplateName=GetMergeMessage("Followup using...",modeArticle)).IsEmpty())
   {
      delete m;
      return;
   }

   FollowupArticle(OrgArticle,TemplateName);
   delete m;
}
//---------------------------------------------------------------------------
void __fastcall FollowupArticle(TStrings *Article, AnsiString &TemplateName)
{
   AnsiString hdr,mID,pststr=QteMarks,blank;
   TStringList *Template = new TStringList();
   GetAppData(Template,TemplateName);

   TStringList *lines = new TStringList();
   THeaderManager *TmpMan = new THeaderManager(Template);
   THeaderManager *ArtMan = new THeaderManager(Article);
   // get special header positions from template if there
   while (!(hdr=TmpMan->PopHeader()).IsEmpty())
   {
      if (hdr.Pos("References: ")==1)
         hdr=ArtMan->Get4Reply("References: ");
      else
      if (hdr.Pos("Newsgroups: ")==1)
         hdr=ArtMan->Get4Reply("Newsgroups: ");
      else
      if (hdr.Pos("Subject: ")==1)
         hdr=ArtMan->Get4Reply("Subject: ");
      lines->Text = lines->Text + hdr;
   }
   hdr = "";
   // add special headers to end of headers if not handled above
   if (!lines->Text.Pos("References: "))
      hdr =ArtMan->Get4Reply("References: ");
   if (!lines->Text.Pos("Newsgroups: "))
      hdr+=ArtMan->Get4Reply("Newsgroups: ");
   if (!lines->Text.Pos("Subject: "))
      hdr+=ArtMan->Get4Reply("Subject: ");
   if (!hdr.IsEmpty())
      lines->Text = lines->Text + hdr;

   lines->Add("");
   lines->Add("In article "+ArtMan->GetDat("Message-ID: "));
   lines->Add(ArtMan->GetDat("From: ")+" wrote: ");

   int i,eoh = ArtMan->Eoh();
   // add quoted article text to new article
   for (i=eoh; i<Article->Count; i++) lines->Add(pststr+Article->Strings[i]);
   lines->Add("");
   // remove trailing nulls from template
   while (Template->Count && Template->Strings[Template->Count-1].IsEmpty())
      Template->Delete(Template->Count-1);
   // copy template sig to lines
   for (i=1; i<Template->Count; i++) lines->Add(Template->Strings[i]);

   // give it to the user
   MessageWin = new TMessageWin(lines,blank,blank,Application->MainForm);
   delete TmpMan;
   delete ArtMan;
   delete lines;
   delete Template;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetMergeMessage(AnsiString &Caption, int mode)
{
   AnsiString tempname;
   TMergeForm *MF = new TMergeForm(Application->MainForm);
   MF->Caption = Caption;//modeArticle ? "Followup using..." : "Reply using...";
   TListBox *LB = MF->ListBox1; LB->Sorted = true;
   GetAppData(LB->Items,UserTemplates);
   LB->Items->Insert(0,mode==modeArticle ? "<new article>":"<new nessage>");
   LB->ItemIndex = 0;
   CenterDialog(MF);
   MF->ShowModal();
   if (MF->ModalResult==mrOk)
   {
      switch (LB->ItemIndex)
      {
         case-1: break;
         case 0:
            tempname = mode==modeArticle ? DefaultArticle : DefaultMessage;
            break;
         default:
            tempname = UserTemplates+PS+LB->Items->Strings[LB->ItemIndex];
      }
   }
   delete MF;
   return tempname;
}
//---------------------------------------------------------------------------
__fastcall TMergeForm::TMergeForm(TComponent* Owner)
  : TForm(Owner)
{
   Templates = new TStringList();
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && ListBox1->ItemIndex<0)
   {
      MsgBoxHwnd(Handle,
         AnsiString("You must select a template!"),
         "Nothing Selected",
         MB_OK);
      CanClose = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::FormDestroy(TObject *Sender)
{
   delete Templates;
}
//---------------------------------------------------------------------------
void __fastcall TMergeForm::ListBox1DblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
