//---------------------------------------------------------------------------
// MixDir() is in global.cpp
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpDlg.h"
#include "Global.h"
#include "Wiper.h"
#include "Mixmaster.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpForm *PgpForm;
//---------------------------------------------------------------------------
__fastcall TPgpForm::TPgpForm(TComponent* Owner)
  : TForm(Owner)
{
   TheText = new TStringList();
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
}
//---------------------------------------------------------------------------
__fastcall TPgpForm::TPgpForm(AnsiString PubRing, AnsiString SecRing, TForm* Owner)
 : TForm(Owner)
{
   dat = buf_new(); pas = buf_new();
   dat->sensitive = pas->sensitive = true;
   PKeyRing = PubRing; SKeyRing = SecRing;
   TheText = new TStringList();
   MainForm = (TForm*)Owner;
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
}
//---------------------------------------------------------------------------
__fastcall TPgpForm::~TPgpForm()
{
   delete TheText;
   buf_free(pas);
   buf_free(dat);
}
//---------------------------------------------------------------------------
void __fastcall TPgpForm::FormShow(TObject *Sender)
{
   CenterDialog(this,MainForm);
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::SignMessage(TStrings *message, AnsiString &sigid,
   AnsiString &passphrase)
{
   Mode = modePgpSignMessage;
   TheText->Text = message->Text;
   Cap = "...signing message...";
   Passphrase = &passphrase;
   Caption = "Pgp";
   SigId = sigid;
   ShowModal();
   switch (Result)
   {
      case -1: MsgBoxHwnd(Handle,"Specified key not found!","Sign Error",MB_OK); break;
      case  0: message->SetText((char*)dat->data); break;
      default: MsgBoxHwnd(Handle,"PGP signing error: "+AnsiString(Result),"PGP Error",MB_OK);
   }
   if (Result!=0) ModalResult = mrCancel;
   return ModalResult;
}
//---------------------------------------------------------------------------
void __fastcall TPgpForm::Timer1Timer(TObject *Sender)
{
   int i;
   Timer1->Enabled = false;
   Label1->Caption = Cap;
   switch (Mode)
   {
      case modePgpSignMessage:
         buf_sets(pas,Passphrase->c_str());
         ClearString(*Passphrase);
         for (i=0; i<TheText->Count; i++)
            buf_appends(dat,AnsiString(TheText->Strings[i]+"\n").c_str());
         Result = pgp_mailenc(PGP_SIGN,dat,SigId.c_str(),pas,NULL,SKeyRing.c_str());
         break;
      case modePgpCEncryptMessage:
         break;
      case modePgpEncryptSignMessage:
         break;
 //     case modePgpDecryptConventional: PgpDecryptConventional(); break;
//      case modePgpEncryptFile: PgpEncryptFile(); break;
//      case modePgpDecryptFile: PgpDecryptFile(); break;
   }
   if (ModalResult==mrNone)
       ModalResult=mrOk;
 }
//---------------------------------------------------------------------------
/*int __fastcall PgpEncryptMessage(TStringList *Msg, TStringList *Recips,const AnsiString &PKeyRing)
{
   PgpForm = new TPgpForm(Application->MainForm);
   PgpForm->Cap = "...encrypting message...";
   PgpForm->Recips = Recips;
   PgpForm->PKeyRing = PKeyRing;
   PgpForm->Message->Text = Msg->Text;
   PgpForm->Mode = modePgpEncryptMessage;
   PgpForm->Caption = "Pgp";
   PgpForm->ShowModal();
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Msg->Text = PgpForm->Message->Text;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
/*int __fastcall PgpDecryptConventional(TStringList *Data, TDataBuf *Passphrase)
{
   PgpForm = new TPgpForm(Application->MainForm);
   PgpForm->Cap = "...decrypting message...";
   PgpForm->Message->Text = Data->Text;
   PgpForm->Mode = modePgpDecryptConventional;
   PgpForm->Caption = "Pgp";
   Passphrase->Decrypt(BUFWORD);
   PgpForm->Password = Passphrase; PgpForm->ShowModal();
   Passphrase->Encrypt(BUFWORD);
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Data->Text = PgpForm->Message->Text;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpEncryptSignMessage(TStringList *Msg, TStringList *Recips, const AnsiString &SigId,
   TDataBuf *Password, const AnsiString &PKeyRing, const AnsiString &SKeyRing)
{
   PgpForm = new TPgpForm(Application->MainForm);
   PgpForm->Cap = "...encrypt/signing...";
   PgpForm->SigId = SigId;
   PgpForm->Recips = Recips;
   PgpForm->PKeyRing = PKeyRing;
   PgpForm->SKeyRing = SKeyRing;
   PgpForm->Message->Text = Msg->Text;
   PgpForm->Mode = modePgpEncryptSignMessage;
   PgpForm->Caption = "Pgp";
   Password->Decrypt(BUFWORD);
   PgpForm->Password = Password; PgpForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   if (ret==mrOk) Msg->Text = PgpForm->Message->Text;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpEncryptFile(TDataBuf *Password, AnsiString &Filename, AnsiString &Ext)
{
   PgpForm = new TPgpForm(Application->MainForm);
   PgpForm->Cap = "...encrypting "+ExtractFileName(AppDat.LowerCase())+"...";
   PgpForm->Filename = Filename;//.LowerCase();
   PgpForm->NewExt = Ext;
   PgpForm->Mode = modePgpEncryptFile;
   PgpForm->Caption = "Pgp";
   Password->Decrypt(BUFWORD);
   PgpForm->Password = Password; PgpForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall PgpDecryptFile(TDataBuf *Password, AnsiString &Filename, AnsiString &Ext)
{
   PgpForm = new TPgpForm(Application->MainForm);
   PgpForm->Cap = "...decrypting "+ExtractFileName(AppPgp.LowerCase())+"...";
   PgpForm->Filename = Filename;//.LowerCase();
   PgpForm->NewExt = Ext;
   PgpForm->Mode = modePgpDecryptFile;
   PgpForm->Caption = "Pgp";
   Password->Decrypt(BUFWORD);
   PgpForm->Password = Password;
   PgpForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   delete PgpForm;
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall MixConfigNym(TDataBuf *Password, TStrings *message, TComponent *Owner)
{
   PgpForm = new TPgpForm(Owner);
   PgpForm->Cap = "  Encrypting Nym Config...";
   PgpForm->Message = message;
   PgpForm->Mode = modeMixConfigNym;
   PgpForm->Caption = "Mixmaster";
   Password->Decrypt(BUFWORD);
   PgpForm->Password = Password; PgpForm->ShowModal();
   Password->Encrypt(BUFWORD);
   int ret = PgpForm->ModalResult;
   if (PgpForm->Result!=0) ret = mrCancel;
   delete PgpForm;
   return ret;
}
*/
//---------------------------------------------------------------------------
/*__fastcall TPgpForm::TPgpForm(TComponent* Owner)
  : TForm(Owner)
{
   Position = poScreenCenter;
   if (Application->MainForm)
   {
      Position = poDesigned;
      TForm *Main = Application->MainForm;
      Top = Main->Top+((Main->Height-Height)/2);
      Left = Main->Left+((Main->Width-Width)/2);
   }
   ProgressBar = NULL;
   Feedback = NULL;
   Messages = NULL;
   Message = new TStringList();
}
*///---------------------------------------------------------------------------
void __fastcall TPgpForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
/*
   switch (Mode)
   {
      case modePgpEncryptFile:
      {
         AnsiString pgpname = ChangeFileExt(Filename,PgpExt);
         if (ModalResult==mrCancel && FileExists(pgpname))
            remove(pgpname.c_str());
         break;
      }
      case modePgpDecryptFile:
      {
         AnsiString datname = ChangeFileExt(Filename,DatExt);
         if (ModalResult==mrCancel && FileExists(datname))
            remove(datname.c_str());
         break;
      }
   }
   Sleep(500);
*/
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::CEncryptMessage(TStrings *Message, AnsiString &Passphrase)
{
   Mode = modePgpCEncryptMessage;
   Cap = "...encrypting message...";
   Caption = "Pgp";

   BUFFER *dat = buf_new(), *enc = buf_new();
   dat->sensitive = true; enc->sensitive = true;
   buf_appends(enc,Passphrase.c_str());
   ClearString(Passphrase);

   for (int i=0; i<Message->Count; i++)
      buf_appends(dat,AnsiString(Message->Strings[i]+"\n").c_str());

   Result = pgp_encrypt(PGP_CONVENTIONAL|PGP_TEXT,dat,enc,NULL,NULL,PKeyRing.c_str(),NULL);
   switch (Result)
   {
      case PGP_PASS: MsgBoxHwnd(Handle,"Bad signature passphrase!","PGP Error",MB_OK); break;
      case -1: MsgBoxHwnd(Handle,"Specified key not found!","PGP Error",MB_OK); break;
      case  0: Message->Text = (char*)dat->data; break;
      default:
         MsgBoxHwnd(Handle,"PGP encrypt error: "+AnsiString(Result),"PGP Error",MB_OK);
   }
   buf_free(enc); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::EncryptMessage()
{
   BUFFER *dat = buf_new(), *enc = buf_new();
   dat->sensitive = true; enc->sensitive = true;
   Application->ProcessMessages();
   buf_append(enc,(byte*)Recips->Text.c_str(),Recips->Text.Length());
   buf_append(dat,(byte*)TheText->Text.c_str(),TheText->Text.Length());
   Result = pgp_encrypt(PGP_ENCRYPT|PGP_TEXT,dat,enc,NULL,NULL,PKeyRing.c_str(),NULL);
   switch (Result)
   {
      case PGP_PASS: MsgBoxHwnd(Handle,"Bad signature passphrase!","PGP Error",MB_OK); break;
      case -1: MsgBoxHwnd(Handle,"Specified key not found!","PGP Error",MB_OK); break;
      case  0: TheText->Text = AnsiString((char*)dat->data); break;
      default:
         MsgBoxHwnd(Handle,"PGP encrypt error: "+AnsiString(Result),"PGP Error",MB_OK);
   }
   Application->ProcessMessages();
   buf_free(enc); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::PgpEncryptSignMessage()
{
/*
   BUFFER *dat = buf_new(), *enc = buf_new(), *sig = buf_new(), *pas = buf_new();
   dat->sensitive = enc->sensitive = sig->sensitive = pas->sensitive = true;
   Application->ProcessMessages();
   buf_append(enc,(byte*)Recips->Text.c_str(),Recips->Text.Length());
   buf_append(dat,(byte*)TheText->Text.c_str(),TheText->Text.Length());
   buf_append(sig,(byte*)SigId.c_str(),SigId.Length());
   buf_append(pas,(byte*)Password->data,Password->length);
   Result = pgp_encrypt(PGP_SIGN|PGP_ENCRYPT|PGP_TEXT,dat,enc,sig,pas,
      PKeyRing.c_str(),SKeyRing.c_str());
   switch (Result)
   {
      case PGP_PASS: MsgBoxHwnd(Handle,"Bad signature passphrase!","PGP Error",MB_OK); break;
      case -1: MsgBoxHwnd(Handle,"Specified key not found!","PGP Error",MB_OK); break;
      case  0: TheText->Text = AnsiString((char*)dat->data); break;
      default:
         MsgBoxHwnd(Handle,"PGP encrypt/sign error: "+AnsiString(Result),"PGP Error",MB_OK);
   }
   Application->ProcessMessages();
   buf_free(pas); buf_free(sig); buf_free(enc); buf_free(dat);
*/
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::PgpDecryptConventional()
{
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   Application->ProcessMessages();
/*
   Password->Decrypt(BUFWORD);
   buf_append(pas,(byte*)Password->data,Password->length);
   Password->Encrypt(BUFWORD);
*/
   buf_append(dat,(byte*)TheText->Text.c_str(),TheText->Text.Length());
   Result = pgp_decrypt(dat,pas,NULL,NULL,NULL);
   if (!Result) TheText->SetText((char*)dat->data);

   Application->ProcessMessages();
   buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::PgpEncryptFile()
{
   BUFFER *dat = buf_new(), *pas = buf_new(), *enc = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   Application->ProcessMessages();
//   Password->Decrypt(BUFWORD);
   buf_append(pas,(byte*)Passphrase->c_str(),Passphrase->Length());
//   Password->Encrypt(BUFWORD);
   buf_readfile(dat,Filename.c_str());
   Result = pgp_encrypt(PGP_CONVENTIONAL|PGP_NOARMOR,dat,pas,NULL,enc,NULL,NULL);
   if (!Result) buf_writefile(dat,ChangeFileExt(Filename,NewExt).c_str(),"wb");

   Application->ProcessMessages();
   buf_free(enc); buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
int __fastcall TPgpForm::PgpDecryptFile()
{
   BUFFER *dat = buf_new(), *pas = buf_new();
   dat->sensitive = true; pas->sensitive = true;
   Application->ProcessMessages();
   //Password->Decrypt(BUFWORD);
   buf_append(pas,(byte*)Passphrase->c_str(),Passphrase->Length());
   //Password->Encrypt(BUFWORD);
   buf_readfile(dat,Filename.c_str());
   Result = pgp_decrypt(dat,pas,NULL,NULL,NULL);
   if (!Result) buf_writefile(dat,ChangeFileExt(Filename,NewExt).c_str(),"wb");

   Application->ProcessMessages();
   buf_free(pas); buf_free(dat);
   return Result;
}
//---------------------------------------------------------------------------
/*void __fastcall TPgpForm::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Label1->Caption = Cap;
   switch (Mode)
   {
//      case modePgpEncryptFile: PgpEncryptFile(); break;
//      case modePgpDecryptFile: PgpDecryptFile(); break;
      case modePgpSignMessage: PgpSignMessage(); break;
      case modePgpEncryptMessage: PgpEncryptMessage(); break;
      case modePgpEncryptSignMessage: PgpEncryptSignMessage(); break;
//      case modePgpEncryptConventional: PgpEncryptConventional(); break;
 //     case modePgpDecryptConventional: PgpDecryptConventional(); break;
   }
   Application->ProcessMessages();
   if (ModalResult == mrNone)
       ModalResult = mrOk;
 }*/
//---------------------------------------------------------------------------
void __fastcall TPgpForm::Timer2Timer(TObject *Sender)
{
   if (Label1->Caption.IsEmpty()) Label1->Caption = Cap;
   else Label1->Caption = "";
}
//---------------------------------------------------------------------------
void __fastcall TPgpForm::Timer3Timer(TObject *Sender)
{
   ProgressBar->Position += (WORD)1;
   if (*Cancelled && ProgressBar->Position<100)
   {
      int start = ProgressBar->Position;
      for (int i=start; i<=100; i++)
      {
         ProgressBar->Position += (WORD)1;
         Application->ProcessMessages();
         Sleep(1);
      }
      Timer3->Enabled = false;
      ModalResult = mrCancel;
   }
}
//---------------------------------------------------------------------------







