//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "qspgpver.h"
#include "pgprecips.h"
#include "PgpPassEx.h"
#include "global.h"
#include "fileman.h"
#include "headman.h"
#include "pgpdlg.h"
#include "MixmastDlg.h"
#include "pgp.h"

USERES("QSPGP.res");
USEUNIT("QSpgpVer.cpp");
USEFORM("PgpRecips.cpp", PgpRecipForm);
USEFORM("Wiper.cpp", WipeForm);
USEUNIT("pgp.cpp");
USEUNIT("Global.cpp");
USEUNIT("Mixmaster.cpp");
USEUNIT("Console.cpp");
USEUNIT("Fmxutils.cpp");
USEFORM("PGPpassEx.cpp", PgpPassForm);
USEUNIT("FileMan.cpp");
USEUNIT("HeadMan.cpp");
USEFORM("MixmastDlg.cpp", MixForm);
USEFORM("PgpDlg.cpp", PgpForm);
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __fastcall PgpInit(HINSTANCE HMixLib,
   HINSTANCE HSSLLib, TForm *MainForm, HWND AppHandle);
extern "C" __declspec(dllexport) char* __fastcall PgpSignMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptMessage(char *Message);
//extern "C" __declspec(dllexport) char* __fastcall GetPgpEncryptList(char *Recipients);
extern "C" __declspec(dllexport) char* __fastcall GetPgpLibVersion();
extern "C" __declspec(dllexport) char* __fastcall GetPgpLibName();
bool __fastcall CutMessageAtCutmarks(TStrings *msg);
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------
void  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   hMixLib=HMixLib; hSSLLib=HSSLLib;
   Application->Handle=AppHandle;
   ActMainForm=MainForm;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptMessage(char *Message)
{
   AnsiString passphrase,pgpmsg;
   TStringList *msg = new TStringList(); msg->SetText(Message);
   TStringList *recips = new TStringList();
   THeaderManager *headers = new THeaderManager(msg);
   headers->GetRecipsFull("To: ",recips,msg);
   delete headers;

   if (!PGPgetEncryptList(recips))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   bool cEncrypt = recips->Text==UseConventional+"\r\n";
   if (cEncrypt && !PGPgetConventionalPassphrase(passphrase,ActMainForm))
   {
      delete headers;
      delete recips;
      delete msg;
      return NULL;
   }

   CutMessageAtCutmarks(msg);
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx>=msg->Count || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      MsgBoxHwnd(AppMainForm->Handle,
         AnsiString("Your message does not appear to have an empty\n")+
         AnsiString("line between headers and body!"),
         "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete recips;
      delete msg;
      return NULL;
   }

   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }

   int result=16; // just a non-error number
   if (mail->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),ActMainForm);
      if (cEncrypt)
         result = Pgp->CEncryptMessage(mail,passphrase);
//      else
//         mrResult = Pgp->EncryptMessage(mail,recips);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to encrypt!","QS PGP Encrypt Error",
         MB_OK);

   if (result==0)
   {
      msg->AddStrings(mail); mail->Clear();
      pgpmsg = msg->Text;
   }

   delete mail;
   delete recips;
   delete msg;
   return pgpmsg.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall PgpSignMessage(char *Message)
{
   static AnsiString pgpmsg;
   TStringList *msg = new TStringList(); msg->SetText(Message);
   THeaderManager *Headers = new THeaderManager(msg);
   AnsiString keyid=Headers->GetDat("From: ");
   delete Headers;

   TStringList *keys = new TStringList();
   TPgpDb *pgpdb = new TPgpDb(PgpPublicRing(),PgpSecretRing());
   TPgpKey *Key = pgpdb->FirstKey();
   while (Key)
   {
      if (Key->IsPair)
      {
         TPgpKey *skey = Key->SecKey;
         if (skey->UserIds->Count)
         {
            for (int i=0; i<skey->UserIds->Count; i++)
               keys->Add(skey->UserIds->Strings[i]);
         }
      }
      Key = Key->Next;
   }
   delete pgpdb;
   if (!keys->Count)
   {
      MsgBox("No keys found!","QS PGP Error",MB_OK);
      delete keys;
      delete msg;
      return NULL;
   }

   AnsiString passphrase;
   int current=keys->IndexOf(keyid);
   if (!PGPgetKeyidAndPassphrase(keys,current,passphrase,ActMainForm))
   {
      delete keys;
      delete msg;
      return NULL;
   }

   int first=keyid.Pos("<")+1,last=keyid.Pos(">")-1;
   keyid = keyid.SubString(first,last?last-(first-1):keyid.Length());

   CutMessageAtCutmarks(msg);
   if (msg->Count)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),ActMainForm);
      if (Pgp->SignMessage(msg,keyid,passphrase)==mrOk)
         pgpmsg = msg->Text;
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to sign!","PGP Sign Error",MB_OK);

   delete keys;
   delete msg;
   return pgpmsg.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
/*char* __fastcall GetPgpEncryptList(char *ProposedList)
{
   TPgpRecipForm *pf = new TPgpRecipForm(Application->MainForm);
   pf->ListBox2->Items->SetText(ProposedList);
   if (Application->ShowMainForm==true) CenterDialog(pf,AppMainForm);
   else pf->Position = poScreenCenter;

   pf->ShowModal();
   TStringList *retlist = new TStringList();
   if (pf->ModalResult==mrOk)
   {
      AnsiString s;
      if (pf->Conventional->Checked)
         retlist->Text = UseConventional;
      else
      {
         TStrings *list = pf->ListBox2->Items;
         for (int i=0; i<list->Count; i++)
         {
            s = list->Strings[i];
            retlist->Add(s.SubString(1,s.Pos("(")-1).TrimRight());
         }
      }
   }
   AnsiString rettext = retlist->Text;
   delete retlist;
   delete pf;
   return rettext.c_str();
}*/
//---------------------------------------------------------------------------
bool __fastcall CutMessageAtCutmarks(TStrings *msg)
{
   bool cut = false;
   if (msg->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      while (msg->Count)
      {
         AnsiString line = msg->Strings[msg->Count-1];
         msg->Delete(msg->Count-1);
         if (line.TrimRight()==CutMarks) break;
      }
      cut = true;
   }
   return cut;
}
//---------------------------------------------------------------------------

